Bug 21295 - GETAI(AF_UNSPEC) drops IPv6 addresses if nss module does not support gethostbyname4_r
Summary: GETAI(AF_UNSPEC) drops IPv6 addresses if nss module does not support gethostb...
Status: RESOLVED FIXED
Alias: None
Product: glibc
Classification: Unclassified
Component: network (show other bugs)
Version: unspecified
: P2 normal
Target Milestone: 2.26
Assignee: Florian Weimer
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2017-03-23 13:14 UTC by Dmitry Bilunov
Modified: 2018-01-04 12:25 UTC (History)
2 users (show)

See Also:
Host:
Target:
Build:
Last reconfirmed: 2017-04-20 00:00:00
fweimer: security-


Attachments
Here is how to reproduce the issue in docker. (848 bytes, text/plain)
2017-03-23 13:22 UTC, Dmitry Bilunov
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Dmitry Bilunov 2017-03-23 13:14:03 UTC
GETAI(AF_UNSPEC) only returns the IPv4 result 

CVE-2016-3706 patch introduces a regression which disrupts connectivity
from IPv6-only to dual-stack hosts having an old libnss_dns library.

It affects users of nss modules which does not support new
getaddrinfo4_r interface — glibc falls back to using older
getaddrinfo{2,3}_r interfaces. This bug breaks connectivity
on IPv6-only hosts if you try to connect to a dual-stack
machine — only IPv4 addresses will be provided by getaddrinfo call.

How to reproduce:

Sample program:

#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main() {
        struct addrinfo *result;
        struct addrinfo *res;
        int error;
        char *host = "ya.ru";
        char buf[512];

        /* resolve the domain name into a list of addresses */
        error = getaddrinfo(host, NULL, NULL, &result);
        if (error != 0) {
                if (error == EAI_SYSTEM) {
                        perror("getaddrinfo");
                } else {
                        fprintf(stderr, "error in getaddrinfo: %s\n", gai_strerror(error));
                }
                exit(EXIT_FAILURE);
        }

        for (res = result; res != NULL; res = res->ai_next) {
                if (res->ai_family == AF_INET)
                        inet_ntop(res->ai_family, &((struct sockaddr_in *)res->ai_addr)->sin_addr, buf, sizeof(buf));
                else if (res->ai_family == AF_INET6)
                        inet_ntop(res->ai_family, &((struct sockaddr_in6 *)res->ai_addr)->sin6_addr, buf, sizeof(buf));
                else
                        continue;
                puts(buf);
        }

        freeaddrinfo(result);
        return 0;
}

Build and run program:

# gcc foo.c
# ./a.out | sort -u

Actual Result:

213.180.193.3
213.180.204.3
93.158.134.3

Expected Result:

213.180.193.3
213.180.204.3
2a02:6b8::3
93.158.134.3

This is because IPv6 results would get discarded after a successive call
to convert_hostent_to_gaih_addrtuple.
Comment 1 Dmitry Bilunov 2017-03-23 13:22:27 UTC
Created attachment 9933 [details]
Here is how to reproduce the issue in docker.
Comment 2 Dmitry Bilunov 2017-03-23 13:23:54 UTC
I propose a fix in libc-alpha@ mailing list: [PATCH][BZ 21295] getaddrinfo: do not overwrite IPv6 IPs with IPv4 when using AF_UNSPEC
Comment 3 Florian Weimer 2017-04-20 14:30:00 UTC
With the current upstream sources, this is reproducible with AF_INET6 and the AI_V4MAPPED and AI_ALL flags in the hints.
Comment 4 cvs-commit@gcc.gnu.org 2017-06-24 14:59:20 UTC
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, master has been updated
       via  513a71a420e74270a6a9702ec916e807be51350a (commit)
       via  5cf88a83f27b0cd2d5a83511930e40d716c939eb (commit)
      from  388b4f1a02f3a801965028bbfcd48d905638b797 (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=513a71a420e74270a6a9702ec916e807be51350a

commit 513a71a420e74270a6a9702ec916e807be51350a
Author: Florian Weimer <fweimer@redhat.com>
Date:   Sat Jun 24 16:51:31 2017 +0200

    resolv/tst-resolv-basic: Add test cases for bug 21295

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=5cf88a83f27b0cd2d5a83511930e40d716c939eb

commit 5cf88a83f27b0cd2d5a83511930e40d716c939eb
Author: Dmitry Bilunov <kmeaw@kmeaw.com>
Date:   Sat Jun 24 16:49:34 2017 +0200

    getaddrinfo: Merge IPv6 addresses and IPv4 addresses [BZ #21295]

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog                   |   11 +++++++++++
 resolv/tst-resolv-basic.c   |   16 ++++++++++++++++
 sysdeps/posix/getaddrinfo.c |    8 ++++----
 3 files changed, 31 insertions(+), 4 deletions(-)
Comment 5 Florian Weimer 2017-06-24 15:00:48 UTC
Fixed in 2.26.
Comment 6 cvs-commit@gcc.gnu.org 2017-08-02 13:57:01 UTC
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The annotated tag, glibc-2.26 has been created
        at  ef82e26a1d7247c6b0b85e27880113a7690af64d (tag)
   tagging  1c9a5c270d8b66f30dcfaf1cb2d6cf39d3e18369 (commit)
  replaces  glibc-2.25
 tagged by  Siddhesh Poyarekar
        on  Wed Aug 2 19:12:20 2017 +0530

- Log -----------------------------------------------------------------
FROM: Siddhesh Poyarekar <siddhesh@sourceware.org>
SUBJECT: The GNU C Library version 2.26 is now available

The GNU C Library
=================

The GNU C Library version 2.26 is now available.

The GNU C Library is used as *the* C library in the GNU system and
in GNU/Linux systems, as well as many other systems that use Linux
as the kernel.

The GNU C Library is primarily designed to be a portable
and high performance C library.  It follows all relevant
standards including ISO C11 and POSIX.1-2008.  It is also
internationalized and has one of the most complete
internationalization interfaces known.

The GNU C Library webpage is at http://www.gnu.org/software/libc/

Packages for the 2.26 release may be downloaded from:
        http://ftpmirror.gnu.org/libc/
        http://ftp.gnu.org/gnu/libc/

The mirror list is at http://www.gnu.org/order/ftp.html

NEWS for version 2.26
=====================

Major new features:

* A per-thread cache has been added to malloc. Access to the cache requires
  no locks and therefore significantly accelerates the fast path to allocate
  and free small amounts of memory. Refilling an empty cache requires locking
  the underlying arena. Performance measurements show significant gains in a
  wide variety of user workloads. Workloads were captured using a special
  instrumented malloc and analyzed with a malloc simulator. Contributed by
  DJ Delorie with the help of Florian Weimer, and Carlos O'Donell.

* Unicode 10.0.0 Support: Character encoding, character type info, and
  transliteration tables are all updated to Unicode 10.0.0, using
  generator scripts contributed by Mike FABIAN (Red Hat).
  These updates cause user visible changes, especially the changes in
  wcwidth for many emoji characters cause problems when emoji sequences
  are rendered with pango, see for example:
  https://bugzilla.gnome.org/show_bug.cgi?id=780669#c5

* Collation of Hungarian has been overhauled and is now consistent with "The
  Rules of Hungarian Orthography, 12th edition" (Bug 18934).  Contributed by
  Egmont Koblinger.

* Improvements to the DNS stub resolver, contributed by Florian Weimer:

  - The GNU C Library will now detect when /etc/resolv.conf has been
    modified and reload the changed configuration.  The new resolver option
    “no-reload” (RES_NORELOAD) disables this behavior.

  - The GNU C Library now supports an arbitrary number of search domains
    (configured using the “search” directive in /etc/resolv.conf);
    previously, there was a hard limit of six domains.  For backward
    compatibility, applications that directly modify the ‘_res’ global
    object are still limited to six search domains.

  - When the “rotate” (RES_ROTATE) resolver option is active, the GNU C
    Library will now randomly pick a name server from the configuration as a
    starting point.  (Previously, the second name server was always used.)

* The tunables feature is now enabled by default.  This allows users to tweak
  behavior of the GNU C Library using the GLIBC_TUNABLES environment variable.

* New function reallocarray, which resizes an allocated block (like realloc)
  to the product of two sizes, with a guaranteed clean failure upon integer
  overflow in the multiplication.  Originally from OpenBSD, contributed by
  Dennis Wölfing and Rüdiger Sonderfeld.

* New wrappers for the Linux-specific system calls preadv2 and pwritev2.
  These are extended versions of preadv and pwritev, respectively, taking an
  additional flags argument.  The set of supported flags depends on the
  running kernel; full support currently requires kernel 4.7 or later.

* posix_spawnattr_setflags now supports the flag POSIX_SPAWN_SETSID, to
  create a new session ID for the spawned process.  This feature is
  scheduled to be added to the next major revision of POSIX; for the time
  being, it is available under _GNU_SOURCE.

* errno.h is now safe to use from C-preprocessed assembly language on all
  supported operating systems.  In this context, it will only define the
  Exxxx constants, as preprocessor macros expanding to integer literals.

* On ia64, powerpc64le, x86-32, and x86-64, the math library now implements
  128-bit floating point as defined by ISO/IEC/IEEE 60559:2011 (IEEE
  754-2008) and ISO/IEC TS 18661-3:2015.  Contributed by Paul E. Murphy,
  Gabriel F. T. Gomes, Tulio Magno Quites Machado Filho, and Joseph Myers.

  To compile programs that use this feature, the compiler must support
  128-bit floating point with the type name _Float128 (as defined by TS
  18661-3) or __float128 (the nonstandard name used by GCC for C++, and for
  C prior to version 7).  _GNU_SOURCE or __STDC_WANT_IEC_60559_TYPES_EXT__
  must be defined to make the new interfaces visible.

  The new functions and macros correspond to those present for other
  floating-point types (except for a few obsolescent interfaces not
  supported for the new type), with F128 or f128 suffixes; for example,
  strtof128, HUGE_VAL_F128 and cosf128.  Following TS 18661-3, there are no
  printf or scanf formats for the new type; the strfromf128 and strtof128
  interfaces should be used instead.

Deprecated and removed features, and other changes affecting compatibility:

* The synchronization that pthread_spin_unlock performs has been changed to
  now be equivalent to a C11 atomic store with release memory order to the
  spin lock's memory location.  Previously, several (but not all)
  architectures used stronger synchronization (e.g., containing what is
  often called a full barrier).  This change can improve performance, but
  may affect odd fringe uses of spin locks that depend on the previous
  behavior (e.g., using spin locks as atomic variables to try to implement
  Dekker's mutual exclusion algorithm).

* The port to Native Client running on ARMv7-A (--host=arm-nacl) has been
  removed.

* Sun RPC is deprecated.  The rpcgen program, librpcsvc, and Sun RPC headers
  will only be built and installed when the GNU C Library is configured with
  --enable-obsolete-rpc.  This allows alternative RPC implementations, such
  as TIRPC or rpcsvc-proto, to be used.

* The NIS(+) name service modules, libnss_nis, libnss_nisplus, and
  libnss_compat, are deprecated, and will not be built or installed by
  default.

  The NIS(+) support library, libnsl, is also deprecated.  By default, a
  compatibility shared library will be built and installed, but not headers
  or development libraries. Only a few NIS-related programs require this
  library.  (In particular, the GNU C Library has never required programs
  that use 'gethostbyname' to be linked with libnsl.)

  Replacement implementations based on TIRPC, which additionally support
  IPv6, are available from <https://github.com/thkukuk/>.  The configure
  option --enable-obsolete-nsl will cause libnsl's headers, and the NIS(+)
  name service modules, to be built and installed.

* The DNS stub resolver no longer performs EDNS fallback.  If EDNS or DNSSEC
  support is enabled, the configured recursive resolver must support EDNS.
  (Responding to EDNS-enabled queries with responses which are not
  EDNS-enabled is fine, but FORMERR responses are not.)

* res_mkquery and res_nmkquery no longer support the IQUERY opcode.  DNS
  servers have not supported this opcode for a long time.

* The _res_opcodes variable has been removed from libresolv.  It had been
  exported by accident.

* <string.h> no longer includes inline versions of any string functions,
  as this kind of optimization is better done by the compiler.  The macros
  __USE_STRING_INLINES and __NO_STRING_INLINES no longer have any effect.

* The nonstandard header <xlocale.h> has been removed.  Most programs should
  use <locale.h> instead.  If you have a specific need for the definition of
  locale_t with no other declarations, please contact
  libc-alpha@sourceware.org and explain.

* The obsolete header <sys/ultrasound.h> has been removed.

* The obsolete signal constant SIGUNUSED is no longer defined by <signal.h>.

* The obsolete function cfree has been removed.  Applications should use
  free instead.

* The stack_t type no longer has the name struct sigaltstack.  This changes
  the C++ name mangling for interfaces involving this type.

* The ucontext_t type no longer has the name struct ucontext.  This changes
  the C++ name mangling for interfaces involving this type.

* On M68k GNU/Linux and MIPS GNU/Linux, the fpregset_t type no longer has
  the name struct fpregset.  On Nios II GNU/Linux, the mcontext_t type no
  longer has the name struct mcontext.  On SPARC GNU/Linux, the struct
  mc_fq, struct rwindow, struct fpq and struct fq types are no longer
  defined in sys/ucontext.h, the mc_fpu_t type no longer has the name struct
  mc_fpu, the gwindows_t type no longer has the name struct gwindows and the
  fpregset_t type no longer has the name struct fpu.  This changes the C++
  name mangling for interfaces involving those types.

* On S/390 GNU/Linux, the constants defined by <sys/ptrace.h> have been
  synced with the kernel:

    - PTRACE_GETREGS, PTRACE_SETREGS, PTRACE_GETFPREGS and PTRACE_SETFPREGS
      are not supported on this architecture and have been removed.

    - PTRACE_SINGLEBLOCK, PTRACE_SECCOMP_GET_FILTER, PTRACE_PEEKUSR_AREA,
      PTRACE_POKEUSR_AREA, PTRACE_GET_LAST_BREAK, PTRACE_ENABLE_TE,
      PTRACE_DISABLE_TE and PTRACE_TE_ABORT_RAND have been added.

  Programs that assume the GET/SETREGS ptrace requests are universally
  available will now fail to build, instead of malfunctioning at runtime.

Changes to build and runtime requirements:

* Linux kernel 3.2 or later is required at runtime, on all architectures
  supported by that kernel.  (This is a change from version 2.25 only for
  x86-32 and x86-64.)

* GNU Binutils 2.25 or later is now required to build the GNU C Library.

* On most architectures, GCC 4.9 or later is required to build the GNU C
  Library.  On powerpc64le, GCC 6.2 or later is required.

  Older GCC versions and non-GNU compilers are still supported when
  compiling programs that use the GNU C Library.  (We do not know exactly
  how old, and some GNU extensions to C may be _de facto_ required.  If you
  are interested in helping us make this statement less vague, please
  contact libc-alpha@sourceware.org.)

Security related changes:

* The DNS stub resolver limits the advertised UDP buffer size to 1200 bytes,
  to avoid fragmentation-based spoofing attacks (CVE-2017-12132).

* LD_LIBRARY_PATH is now ignored in binaries running in privileged AT_SECURE
  mode to guard against local privilege escalation attacks (CVE-2017-1000366).

* Avoid printing a backtrace from the __stack_chk_fail function since it is
  called on a corrupt stack and a backtrace is unreliable on a corrupt stack
  (CVE-2010-3192).

* A use-after-free vulnerability in clntudp_call in the Sun RPC system has been
  fixed (CVE-2017-12133).

Contributors
============

This release was made possible by the contributions of many people.
The maintainers are grateful to everyone who has contributed
changes or bug reports.  These include:

Adhemerval Zanella
Akhilesh Kumar
Alan Modra
Alexey Neyman
Andreas Schwab
Arjun Shankar
Benjamin Cama
Carlos O'Donell
Chris Leonard
Christian Borntraeger
Christian Brauner
Christopher Chittleborough
Chung-Lin Tang
DJ Delorie
Dennis Wölfing
Dmitry Bilunov
Dmitry V. Levin
Egmont Koblinger
Eyolf Østrem
Florian Weimer
Gabriel F. T. Gomes
Gordana Cmiljanovic
H.J. Lu
Ihar Hrachyshka
Ivo Raisr
Jiong Wang
John David Anglin
Joseph Myers
Justus Winter
Kir Kolyshkin
Marko Myllynen
Massimeddu Cireddu
Matthew Krupcale
Mike FABIAN
Mike Frysinger
Mousa Moradi
Nathan Rossi
Paul Clarke
Paul E. Murphy
Paul Eggert
Peng Wu
Phil Blundell
Prakhar Bahuguna
Rabin Vincent
Rafal Luzynski
Rajalakshmi Srinivasaraghavan
Rical Jasan
Rogerio A. Cardoso
Samuel Thibault
Santhosh Thottingal
Siddhesh Poyarekar
Slava Barinov
Stefan Liebler
Steve Ellcey
Sunyeop Lee
Szabolcs Nagy
Thorsten Kukuk
Tulio Magno Quites Machado Filho
Uros Bizjak
Vladimir Mezentsev
Wainer dos Santos Moschetta
Wilco Dijkstra
Wladimir J. van der Laan
Yury Norov
Zack Weinberg
-----BEGIN PGP SIGNATURE-----

iQEcBAABAgAGBQJZgddcAAoJEHnEPfvxzyGH+WAH/3R1K41WWcqSDxX/fgbDzK53
Rgf2QlO0tgJdprRKodeMEDfEfLxhbyAO/aREiTcy7Jeg9zHpcdJgX5H0hax4MYGW
e9ibTSXlxOPhVBrj3cBF+Y2HcqIen0iLFFI9afpstTPitQKgOLLOfjZVs8RKsAUQ
m8FMfWNXZJmexqFnY9b0gukZEUvou5Fq61jXZH6P99MQfovR6/xBbuCUTkWK+Xjy
JmQ8sz69aoTyPlNJNWlg7lFuLTqRzywYDo4Xf6jL+9tVoaTSaKhil3Ld23gekXFE
TzRXo4xeihMjAxhS43BqaSttbcEV0ha0GVGiVqVZWiM+89wQRzj1UAlxa8Wyhlk=
=Myq/
-----END PGP SIGNATURE-----

Adhemerval Zanella (81):
      Consolidate arm and mips posix_fadvise implementations
      Remove i686, x86_64, and powerpc strtok implementations
      nptl: Remove COLORING_INCREMENT
      aarch64: fix errno address calculation in SYSCALL_ERROR_HANDLER
      Rework -fno-omit-frame-pointer support on i386
      hppa: set __IPC_64 as zero for SysV IPC calls
      Consolidate Linux accept implementation
      Consolidate Linux connect implementation
      Consolidate Linux recvfrom implementation
      Consolidate Linux recv implementation
      Consolidate Linux sendto implementation
      Consolidate Linux send implementation
      build-many-glibcs: Remove no_isolate from SH config
      Fix missing posix_fadvise64 mips64 static build (BZ #21232)
      Fix test-errno issues
      Consolidate set* Linux implementation
      Fix i686 memchr overflow calculation (BZ#21182)
      Fix more test-errno issues
      Remove __ASSUME_REQUEUE_PI
      Remove CALL_THREAD_FCT macro
      Build divdi3 only for architecture that required it
      sparc: Fix .udiv plt on libc
      Consolidate pthreadtype.h placementConsolidate pthreadtype.h placement
      posix: Add cleanup on the trap list for globtest.sh
      Consolidate Linux mmap implementation (BZ#21270)
      Fix missing timespec definition for sys/stat.h (BZ #21371)
      [BZ 21340] add support for POSIX_SPAWN_SETSID
      posix: Remove ununsed posix_spawn internal assignment
      posix: Using libsupport for p{write,read}v tests
      nptl: Using libsupport for tst-cancel4*
      posix: Fix internal p{read,write} plt usage
      Consolidate Linux poll implementation
      Consolidate Linux select implementation
      Consolidate Linux epoll_wait syscall
      manual: Add preadv and pwritev documentation
      Move shared pthread definitions to common headers
      Remove wrong definitions from pthread header refactor
      Consolidate Linux close syscall generation
      Consolidate Linux open implementation
      Consolidate Linux creat implementation
      Consolidate Linux read syscall
      Consolidate Linux write syscall
      Consolidate Linux readv implementation
      Consolidate Linux writev implementation
      powerpc: Fix signal handling in backtrace
      posix: Fix and simplify default p{read,write}v implementation
      posix: Consolidate Linux pause syscall
      posix: Consolidate Linux waitpid syscall
      posix: Consolidate Linux nanosleep syscall
      linux: Consolidate Linux tee implementation
      posix: Consolidate Linux sigsuspend implementation
      posix: Consolidate Linux msync syscall
      posix: Consolidate Linux fdatasync syscall
      posix: Consolidate Linux fsync syscall
      linux: Consolidate Linux vmsplice syscall
      linux: Consolidate Linux splice syscall
      linux: Consolidate Linux open_by_handle_at syscall
      posix: Consolidate Linux mq_timedreceive syscall
      posix: Consolidate Linux mq_timedsend syscall
      Fix makefile rules for vmsplice, splice, and open_by_handle_at
      libio: Avoid dup already opened file descriptor [BZ#21393]
      posix: Implement preadv2 and pwritev2
      posix: Add missing build flags for p{write,read}v2
      nptl: Invert the mmap/mprotect logic on allocated stacks (BZ#18988)
      support: Add optstring support
      linux: Consolidate sync_file_range implementation
      Fix gen-tunables.awk to work with older awk
      Consolidate Linux openat implementation
      posix: Add invalid flags test for p{write,read}v2
      Clean pthread functions namespaces for C11 threads
      Call exit directly in clone (BZ #21512)
      posix: Adapt tst-spawn{2,3} to use libsupport.
      posix: Improve default posix_spawn implementation
      Consolidate Linux fcntl implementation
      posix: Fix default posix_spawn return value
      posix: Add p{read,write}v2 RWF_NOWAIT flag (BZ#21738)
      hppa: Fix clone exit syscall argument passing (BZ#21512)
      alpha: Fix clone exit syscall argument passing (BZ#21512)
      Update sparc ulps
      tunables: Use direct syscall for access (BZ#21744)
      Update Alpha libm-test-ulps

Akhilesh Kumar (42):
      For Breton yesstr/nostr locale are missing
      Added Tok-Pisin locale.
      Pashto yesstr/nostr locale are missing
      Incorrect Full Weekday names for ks_IN@devanagari
      yesstr/nostr missing for Xhosa language locale
      Fix LC_NAME for hi_IN
      Added  missing yesstr and nostr for Tsonga language locale [LC_MESSAGES]
      Added yesstr/nostr for kw_GB
      Fix abday strings for ks_IN@devanagari to match the day strings
      Added yesstr and nostr to zh_HK locale
      Fix abday for ar_SA
      Fixed abday for ar_JO/ar_LB/ar_SY
      Added Samoan language locale for Samoa
      Added Fiji Hindi language locale for Fiji
      Added yesstr/nostr for nds_DE and nds_NL
      Added yesstr and nostr for Tigrinya
      Fix LC_MESSAGES and LC_ADDRESS for anp_IN
      Added yesstr/nostr and fix yesexpr for pap_AW and pap_CW
      Added Tongan language locale for Tonga
      Added yesstr and nostr for aa_ET
      New locale for bi_VU
      Fix country_name in li_NL
      Fix or add int_select international_call_prefixes
      Fix consistency in country_isbn in various locales and add comment to country_num in nr_ZA
      Fix country_post "Country Postal Abbreviations"
      Fix int_select international_call_prefixes
      Added int_select international_call_prefixes
      Add country_name and country_post, and country_isbn for pap_AW and pap_CW
      Add/Fix country_isbn for France
      Added country_isbn for Italy
      Added country_isbn for Republic of Korea
      Added country_name in mai_IN
      Fix LC_TIME for mai_IN
      Added yesstr/nostr for sa_IN
      Fix name_mrs for mag_IN
      Fix inconsistency in country_isbn and missing prefixes
      Remove redundant data for LC_MONETARY for Indian locales
      Removed redundant data for the_NP locale
      Added New Locale mai_NP
      Fix Latin characters and month sequence in mai_IN
      Fix wrong monetary system used in ta_LK locale
      Fix country name in title of mai_NP locale

Alan Modra (6):
      PowerPC64, fix calls to _mcount
      PowerPC64 FRAME_PARM_SAVE
      PowerPC64 sysdep.h tidy
      PowerPC64 strncpy, stpncpy and strstr fixes
      PowerPC64 ENTRY_TOCLESS
      PowerPC64 ELFv2 PPC64_OPT_LOCALENTRY

Alexey Neyman (3):
      sh: Fix building with gcc5/6
      Fix combreloc test with BSD grep
      Fix build with --enable-static-nss [BZ #21088]

Andreas Schwab (7):
      Refer to <signal.h> instead of <pthread.h> in <bits/sigthread.h>
      Remove _dl_platform_string
      Use test-driver in ntpl/tst-fork1.c
      m68k: handle default PIE
      Use test-driver in nptl/tst-fork3.c
      build-many-glibcs.py: also build profiled objects
      Remove extra semicolons in struct pthread_mutex (bug 21804)

Arjun Shankar (2):
      Use test-driver in sysdeps/unix/sysv/linux/tst-clone2.c
      Remove check for NULL buffer passed to `ptsname_r'

Benjamin Cama (1):
      inet: __inet6_scopeid_pton should accept node-local addresses [BZ #21657]

Carlos O'Donell (6):
      Bug 20116: Clarify behaviour of PD->lock.
      Bug 20686: Add el_GR@euro support.
      vfprintf.c: Refactor magic number 32 into EXTSIZ.
      Fixup localedata/ChangeLog.
      rwlock: Fix explicit hand-over (bug 21298)
      mutex: Fix robust mutex lock acquire (Bug 21778)

Chris Leonard (1):
      New locale for agr_PE.

Christian Borntraeger (1):
      s390: optimize syscall function

Christian Brauner (1):
      linux ttyname and ttyname_r: do not return wrong results

Christopher Chittleborough (1):
      Bug 21399: Fix CP1254 comment for U+00EC

Chung-Lin Tang (1):
      Update Nios II ULPs file.

DJ Delorie (9):
      Further harden glibc malloc metadata against 1-byte overflows.
      Tweak realloc/MREMAP comment to be more accurate.
      Add MAINTAINERS
      Add per-thread cache to malloc
      * manual/tunables.texi: Add missing @end deftp.
      Fix BZ #21654 - grp-merge.c alignment
      Extend NSS test suite
      Fix cast-after-dereference
      Correct nss/tst-nss-test5 configuration

Dennis Wölfing (1):
      Add reallocarray function

Dmitry Bilunov (1):
      getaddrinfo: Merge IPv6 addresses and IPv4 addresses [BZ #21295]

Dmitry V. Levin (2):
      Check for __mprotect failure in _dl_map_segments [BZ #20831]
      S390: fix sys/ptrace.h to make it includible again after asm/ptrace.h

Egmont Koblinger (1):
      localedata: hu_HU: fix multiple sorting bugs (bug 18934)

Eyolf Østrem (1):
      localedata: da_DK: set date_fmt [BZ #17297]

Florian Weimer (116):
      sunrpc: Avoid use-after-free read access in clntudp_call [BZ #21115]
      sunrpc: Do not unregister services if not registered [BZ #5010]
      sunrpc: Improvements for UDP client timeout handling [BZ #20257]
      Add scripts/backport-support.sh
      Document and fix --enable-bind-now [BZ #21015]
      Remove header file inclusion guard from elf/get-dynamic-info.h
      tzset: Remove __attribute_noinline__ from compute_offset
      tzset: Remove unused NOID macro
      timezone: Remove TZNAME_MAX limit from sysconf [BZ #15576]
      tzset: Clean up preprocessor macros min, max, sign
      Fix auto-merge issue in ChangeLog
      support_format_dns_packet: Fix CNAME and multiple RR handling
      support: Add error checking to close system calls [BZ #21244]
      support: Explain ignored failures of temporary file removal [BZ #21243]
      resolv: Add test coverage for ns_name_unpack, ns_name_ntop
      nss_dns: Remove superfluous dn_expand call from network handling
      nss_dns: Replace local declarations with declarations from a header file
      resolv: Add tst-resolv-canonname
      resolv: Remove IQUERY support
      manual: readdir, readdir64 are thread-safe
      resolv: Remove internal and unused definitions from <resolv.h>
      resolv: Support an exactly sized buffer in ns_name_pack [BZ #21359]
      resolv: Reduce EDNS payload size to 1200 bytes [BZ #21361]
      resolv: Remove EDNS fallback [BZ #21369]
      Assume that O_NOFOLLOW is always defined
      malloc: Turn cfree into a compatibility symbol
      Assume that pipe2 is always available
      Assume that dup3 is available
      Assume that O_CLOEXEC is always defined and works
      Assume that accept4 is always available and works
      Create more sockets with SOCK_CLOEXEC [BZ #15722]
      resolv: Replace __builtin_expect with __glibc_unlikely/__glibc_likely
      rcmd/rexec: Fix typo in comment
      nss_dns: Correct parentheses for the __glibc_unlikely argument
      manual: Document replacing malloc [BZ #20424]
      Remove <sys/ultrasound.h>
      support: Delete temporary files in LIFO order
      support: Prevent multiple deletion of temporary files
      resolv: Use RES_DFLRETRY consistently [BZ #21474]
      getaddrinfo: Unconditionally use malloc for address list
      support_format_addrinfo: Fix flags and canonname formatting
      inet_pton: Reformat in GNU style
      fork: Remove bogus parent PID assertions [BZ #21386]
      Add internal facility for dynamic array handling
      getaddrinfo: Always allocate canonical name on the heap
      resolv: Tests for various versions of res_init
      getaddrinfo: Fix localplt failure involving strdup
      getaddrinfo: Eliminate another strdup call
      support: Expose TEST_VERIFY_EXIT behavior to GCC optimizers
      malloc: Remove tst-dynarray, tst-dynarray-fail from test-srcs
      dynarray: Implement begin/end functions in the spirit of C++
      configure: Suppress expected compiler error message
      i686: Add missing IS_IN (libc) guards to vectorized strcspn
      dynarray: Use libc_hidden_proto only for !_ISOMAC
      resolv: Make __res_vinit hidden
      resolv: Move res_randomid to its own file
      resolv: Move _res deallocation functions to their own file
      resolv: Remove DEBUG preprocessor conditionals from res_setoptions
      resolv: Introduce is_sort_mask and call it from res_vinit
      resolv: Reformat res_vinit and related functions to GNU style
      resolv: Report allocation errors in __res_vinit
      resolv: Use getline for configuration file reading in res_vinit_1
      CVE-2017-1000366: Ignore LD_LIBRARY_PATH for AT_SECURE=1 programs [BZ #21624]
      ld.so: Reject overly long LD_PRELOAD path elements
      ld.so: Reject overly long LD_AUDIT path elements
      DCIGETTEXT: Do not make copy of localename
      inet: Add IPv6 getaddrinfo coverage to tst-inet6_scopeid_pton.c
      __inet_pton_length: Implement new internal helper function
      getaddrinfo: Avoid stack copy of IPv6 address
      DCIGETTEXT: Use getcwd, asprintf to construct absolute pathname
      Implement allocation buffers for internal use
      _nl_load_domain: Use calloc instead of alloca
      x86-64: memcmp-avx2-movbe.S needs saturating subtraction [BZ #21662]
      resolv: Clean up declarations of the __res_initstamp variable
      resolv/res_libc.c: Reformat to GNU style
      x86-64: Fix comment typo in memcmp-avx2-movbe.S
      inet_pton: Reject IPv6 addresses with many leading zeros [BZ #16637]
      resolv/tst-resolv-basic: Add test cases for bug 21295
      resolv: Call _res_hconf_init from __res_vinit
      resolv: Avoid timeouts in test-resolv-res-init, test-resolv-res_init-thread
      vfprintf: Add test case for user-defined types and format specifiers
      vfprintf: Add test case for multi-byte/wide strings and precision
      vfprintf: Reduce WORK_BUFFER_SIZE for wchar_t builds
      _i18n_number_rewrite: Use struct scratch_buffer
      vfprintf: Use struct scratch_buffer for positional arguments allocation
      vfprintf: Reuse work_buffer in group_number
      vfprintf: Fix tst-vfprintf-mbs-prec and tst-vfprintf-user-type
      resolv: Make RES_ROTATE start with a random name server [BZ #19570]
      support: Report actual exit status in support_capture_subprocess_check
      resolv: Remove DEBUG macro from resolv/res_mkquery.c
      resolv: Reformat resolv/res_mkquery.c to GNU style
      resolv: Move the res_mkquery function to the resolv/mk_query.c file
      resolv: Remove DEBUG from resolv/res_send.c
      resolv: Remove unused resolv/res_debug.h header file
      resolv: Move fp_nquery, fp_query, p_query, _res_opcodes
      resolv: Turn _res_opcodes into a compatibility symbol
      resolv: Move res_isourserver, res_send from res_data.c to res_send.c
      resolv: Move res_query, res_search res_querydomain, hostalias
      resolv: Reformat resolv/res_data.c to GNU style
      resolv: Remove DEBUG from resolv/res_query.c
      resolv: Remove source argument fron res_options
      resolv: Improve debugging output from tst-resolv-res_init
      resolv: Add preinit tests to resolv/tst-resolv-res_init-skeleton.c
      resolv: Introduce struct resolv_context [BZ #21668]
      resolv: Introduce struct resolv_conf with extended resolver state
      resolv: Lift domain search list limits [BZ #19569] [BZ #21475]
      resolv: Mirror the entire resolver configuration in struct resolv_conf
      resolv: Automatically reload a changed /etc/resolv.conf file [BZ #984]
      resolv: Introduce free list for resolv_conf index slosts
      resolv: Fix improper assert in __resolv_conf_attach
      resolv: Fix resolv_conf _res matching
      sysconf: Use conservative default for _SC_NPROCESSORS_ONLN [BZ #21542]
      support: Check isolation of loopback addresses in tst-support-namespace
      support: Add support_chroot_create and support_chroot_free
      support: Add resolver testing mode which does not patch _res
      resolv: Deal with non-deterministic address order in tst-resolv-basic

Gabriel F. T. Gomes (35):
      Move w_lgamma_r to libm-compat-calls-auto
      Move w_lgamma to libm-compat-calls-auto
      Move w_exp to libm-compat-call-auto
      Merge libm-compat-calls-auto and libm-compat-calls
      ldbl-128: Fix y0 and y1 for -Inf input [BZ #21130]
      Fix y0 and y1 exception handling for zero input [BZ #21134]
      Add new templates for IEEE wrappers
      Use internal __feraiseexcept in __iseqsig
      Split helper classification macros from mathcalls.h
      Macroize inclusion of math-finite.h
      Change return type in the declaration of __ieee754_rem_pio2l
      Fix condition for inclusion of math-finite.h for long double
      Remove unneeded declarations from math_private.h
      Macroize function declarations in math_private.h
      float128: Include math-finite.h for _Float128
      float128: Enable use of IEEE wrapper templates
      Convert e_exp2l.c into a template
      float128: Extend __MATH_TG for float128 support
      Include sys/param.h in stdlib/gmp-impl.h instead of redefining MAX/MIN
      float128: Add conversion from float128 to mpn
      Remove duplicated code from __printf_fp_l, __printf_fphex, and __printf_size
      Refactor PRINT_FPHEX_LONG_DOUBLE into a reusable macro
      float128: Add strfromf128
      float128: Add strfromf128, strtof128, and wcstof128 to the manual
      Allow macros prefixed with FLT128 in include/float.h
      Provide an additional macro expansion for F128 in stdlib/tst-strtod.h
      Describe remainder as primary and drem as alternative in the manual
      Include libc-header-start.h in include/float.h
      Prepare the manual to display math errors for float128 functions
      Add libio-mtsafe flags to the build of strfromf128
      Document _FloatN and _FloatNx versions of math functions
      powerpc64le: Check for compiler features for float128
      powerpc64le: Require at least POWER8 for powerpc64le
      float128: Add signbit alternative for old compilers
      powerpc64le: Iterate over all object suffixes when appending -mfloat128

Gordana Cmiljanovic (1):
      mips: Fix store/load gp registers to/from ucontext_t

H.J. Lu (68):
      x86-64: Verify that _dl_runtime_resolve preserves vector registers
      Use index_cpu_RTM and reg_RTM to clear the bit_cpu_RTM bit
      Use CPU_FEATURES_CPU_P to check if AVX is available
      x86-64: Improve branch predication in _dl_runtime_resolve_avx512_opt [BZ #21258]
      Define TEST_FUNCTION_ARGV in elf/tst-dlopen-aout.c
      Check if SSE is available with HAS_CPU_FEATURE
      Add sysdeps/x86/dl-procinfo.c
      x86: Set Prefer_No_VZEROUPPER if AVX512ER is available
      x86: Use AVX2 memcpy/memset on Skylake server [BZ #21396]
      x86: Set dl_platform and dl_hwcap from CPU features [BZ #21391]
      Correct comments in x86_64/multiarch/memcmp.S
      x86: Optimize SSE2 memchr overflow calculation
      x86_64: Remove L(return_null) from rawmemchr.S
      x86: Use __get_cpu_features to get cpu_features
      x86: Don't include cacheinfo.c in ld.so
      Support dl-tunables.list in subdirectories
      Make __tunables_init hidden and avoid PLT
      Add memchr tests for n == 0
      x86_64: Remove redundant REX bytes from memchr.S
      x86: Update __x86_shared_non_temporal_threshold
      benchtests: Add more tests for memrchr
      x86-64: Update LO_HI_LONG for p{readv,writev}{64}v2
      x86_64: Remove redundant REX bytes from memrchr.S
      x86-64: Update strlen.S to support wcslen/wcsnlen
      x86: Add macros to implement ifunce selection in C
      x86-64: Optimize wmemset with SSE2/AVX2/AVX512
      x86-64: Optimize memcmp/wmemcmp with AVX2 and MOVBE
      x86: Don't use dl_x86_cpu_features in cacheinfo.c
      x86-64: Move wcsnlen.S to multiarch/wcsnlen-sse4_1.S
      x86-64: Fold ifunc-sse4_1.h into wcsnlen.c
      x86-64: Rename wmemset.h to ifunc-wmemset.h
      Add more tests for memchr
      ld.so: Consolidate 2 strtouls into _dl_strtoul [BZ #21528]
      x86-64: Optimize memchr/rawmemchr/wmemchr with SSE2/AVX2
      x86-64: Optimize strlen/strnlen/wcslen/wcsnlen with AVX2
      x86-64: Optimize strchr/strchrnul/wcschr with AVX2
      x86-64: Optimize memrchr with AVX2
      x86-64: Optimize strrchr/wcsrchr with AVX2
      x86-64: Correct comments in ifunc-impl-list.c
      x86-64: Implement strcpy family IFUNC selectors in C
      Make copy of <bits/std_abs.h> from GCC 7 [BZ #21573]
      x86-64: Implement memmove family IFUNC selectors in C
      x86-64: Implement memset family IFUNC selectors in C
      x86-64: Implement memcmp family IFUNC selectors in C
      x86-64: Implement strcat family IFUNC selectors in C
      x86-64: Implement wcscpy IFUNC selector in C
      x86-64: Implement strcspn/strpbrk/strspn IFUNC selectors in C
      Remove _dl_out_of_memory from elf/Versions
      tunables: Add IFUNC selection and cache sizes
      Move x86 specific tunables to x86/dl-tunables.list
      x86: Rename glibc.tune.ifunc to glibc.tune.hwcaps
      x86-64: Implement strcmp family IFUNC selectors in C
      x86-64: Optimize L(between_2_3) in memcmp-avx2-movbe.S
      Avoid .symver on common symbols [BZ #21666]
      x86-64: Optimize memcmp-avx2-movbe.S for short difference
      Support building glibc with gold 1.14 or above [BZ #14995]
      i386: Increase MALLOC_ALIGNMENT to 16 [BZ #21120]
      Use __builtin_popcount in __sched_cpucount [BZ #21696]
      x86-64: Align the stack in __tls_get_addr [BZ #21609]
      x86-64: Update comments in ifunc-impl-list.c
      x86-64: Update comments in IFUNC selectors
      x86-64: Test memmove_chk and memset_chk only in libc.so [BZ #21741]
      Don't include _dl_resolve_conflicts in libc.a [BZ #21742]
      Avoid backtrace from __stack_chk_fail [BZ #12189]
      Compile tst-ssp-1.c with -fstack-protector-all
      Don't add stack_chk_fail_local.o to libc.a [BZ #21740]
      i386: Test memmove_chk and memset_chk only in libc.so [BZ #21741]
      Avoid accessing corrupted stack from __stack_chk_fail [BZ #21752]

Ihar Hrachyshka (1):
      Improve country_name in be_BY@latin

Ivo Raisr (1):
      sparc: Remove unused assignment in __clone

Jiong Wang (1):
      [ARM] Fix ld.so crash when built using Binutils 2.29

John David Anglin (17):
      hppa: Fix setting of __libc_stack_end
      Fix BZ #21049.
      Use generic pthread support on hppa.
      Update hppa ulps.
      Fix type in sysdeps/hppa/dl-machine.h.
      Fix failing sNaN tests on hppa.
      Fix guard alignment in allocate_stack when stack grows up.
      Fix [BZ locale/19838].
      Fix [BZ 20098].
      Remove extra braces from sysdeps/hppa/__longjmp.c.
      Remove _exit entry from sysdeps/unix/sysv/linux/hppa/localplt.data.
      Fix syscall cancellation on hppa.
      Fix __setcontext return value on hppa.
      Fix stack offset for r19 load in __getcontext.
      Add CFI annotation.
      Return to caller if dl_fixup fails to resolve callee on hppa.
      [BZ 19170]

Joseph Myers (133):
      Remove before-compile setting in math/Makefile.
      Do not hardcode list of libm functions in libm-err-tab.pl.
      Remove libm-test.inc comment listing functions tested and not tested.
      Move non-function-specific parts of libm-test.inc to separate file.
      Rework gen-libm-test.pl input/output handling.
      Eliminate libm-test.stmp.
      Split auto-libm-test-out by function.
      Split libm-test.inc by function.
      Move libm-test TEST_MSG definitions to libm-test-driver.c.
      Refactor some code in libm-test-driver.c.
      Fix powf inaccuracy (bug 21112).
      Clean up libm vector tests exception test disabling.
      Build most libm-test support code once per type.
      Move -U__LIBC_INTERNAL_MATH_INLINES to test-math-inline.h.
      Move more csin, csinh tests to auto-libm-test-in.
      Move INIT_ARCH_EXT call from libm-test-support to libm-test-driver.
      Move most libmvec test contents from .c to .h files.
      Revert header inclusion changes that break math/ testing on x86_64.
      Move tests of cacos, cacosh to auto-libm-test-*.
      Move tests of casin, casinh to auto-libm-test-*.
      Move tests of catan, catanh to auto-libm-test-*.
      Update arm, mips, powerpc-nofpu libm-test-ulps.
      Remove some unused libm-test exception macros.
      Add IP_RECVFRAGSIZE from Linux 4.10.
      Use Linux 4.10 in build-many-glibcs.py.
      Add TFD_TIMER_CANCEL_ON_SET to sys/timerfd.h.
      Run libm tests separately for each function.
      Regenerate MIPS catan, catanh long double ulps.
      Add more IPV6_* macros to sysdeps/unix/sysv/linux/bits/in.h.
      Fix test-math-vector-sincos.h aliasing.
      Improve float range reduction accuracy near pi/2 (bug 21094).
      Remove C++ namespace handling from glibc headers.
      conformtest: Make more tests into compilation tests.
      conformtest: Support system-specific XFAILs.
      conformtest: Skip execution tests when cross-compiling.
      conformtest: Add alpha XFAIL for struct netent n_net type (bug 21260).
      Add missing piece to last ChangeLog entry.
      conformtest: Add mips XFAIL for struct stat st_dev type (bug 17786).
      Make alpha termios.h define IXANY unconditionally (bug 21259).
      conformtest: Handle conditional XFAILs with allow-header.
      Fix sparc64 bits/setjmp.h namespace (bug 21261).
      conformtest: XFAIL tv_nsec tests for x32 (bug 16437).
      Fix alpha termios.h NL2, NL3 namespace (bug 21268).
      conformtest: Add mips XFAIL for struct stat st_rdev type (bug 21278).
      conformtest: Add x32 XFAILs for mq_attr element types (bug 21279).
      Regenerate INSTALL.
      Define more termios.h macros unconditionally for alpha (bug 21277).
      Fix bits/socket.h IOC* namespace issues (bug 21267).
      conformtest: Enable tests when cross compiling.
      Do not use wildcard symbol names for public versions in Versions files.
      conformtest: Allow *_t in sys/socket.h.
      Fix sys/socket.h namespace issues from sys/uio.h inclusion (bug 21426).
      Default build-many-glibcs.py to GCC 7 branch.
      conformtest: Fix XPG standard naming.
      conformtest: Allow time.h inclusion from semaphore.h for XOPEN2K.
      Default Linux kernel version in build-many-glibcs.py to 4.11.
      Add PF_SMC, AF_SMC from Linux 4.11 to bits/socket.h.
      Add TCP_FASTOPEN_CONNECT from Linux 4.11 to netinet/tcp.h.
      Add HWCAP_ASIMDRDM from Linux 4.11 to AArch64 bits/hwcap.h.
      Use __glibc_reserved convention in mcontext, sigcontext (bug 21457).
      Fix signal.h bsd_signal namespace (bug 21445).
      Fix network headers stdint.h namespace (bug 21455).
      Require Linux kernel 3.2 or later on x86 / x86_64.
      Remove __ASSUME_GETCPU_SYSCALL.
      Remove __ASSUME_PROC_PID_TASK_COMM.
      Assume prlimit64 is available.
      Simplify recvmmsg code.
      Simplify sendmmsg code.
      Simplify accept4, recvmmsg, sendmmsg code.
      Remove MIPS32 accept4, recvmmsg, sendmmsg implementations.
      Fix rawmemchr build with GCC 8.
      Condition some sys/ucontext.h contents on __USE_MISC (bug 21457).
      Remove __ASSUME_STATFS_F_FLAGS.
      Remove useless SPARC signbit aliases.
      Create and use first-versions.h with macros for function symbol versions.
      Also create and use ldbl-compat-choose.h.
      Split up bits/sigstack.h.
      Fix sys/ucontext.h namespace from signal.h etc. inclusion (bug 21457).
      Fix sigstack namespace (bug 21511).
      Fix more namespace issues in sys/ucontext.h (bug 21457).
      conformtest: Correct signal.h expectations for XPG4 / XPG42.
      Fix sigevent namespace (bug 21543).
      Fix struct sigaltstack namespace (bug 21517).
      Define SIG_HOLD for XPG4 (bug 21538).
      Fix tst-timezone race (bug 14096).
      Fix include paths in include/bits/types/*.h.
      conformtest: Correct sys/wait.h expectations for XPG4.
      Condition signal.h inclusion in sys/wait.h (bug 21560).
      Fix sigpause namespace (bug 21554).
      Update nios2, sparc32 localplt.data files for recent GCC change.
      Fix waitid namespace (bug 21561).
      Fix sigwait namespace (bug 21550).
      Fix XPG4 bsd_signal namespace (bug 21552).
      Update timezone code from tzcode 2017b.
      Define struct rusage in sys/wait.h when required (bug 21575).
      Fix signal stack namespace (bug 21584).
      Fix siginterrupt namespace (bug 21597).
      Fix another x86 sys/ucontext.h namespace issue (bug 21457).
      Require GCC 4.9 or later for building glibc.
      Fix wait3 namespace (bug 21625).
      Remove pre-GCC-4.9 MIPS code.
      conformtest: XFAIL uc_sigmask test for ia64 (bug 21634).
      conformtest: XFAIL uc_mcontext test for powerpc32 (bug 21635).
      Fix tile SA_* conditions for POSIX.1:2008 (bug 21622).
      Fix float128 uses of xlocale.h.
      Make errno-setting libm templates include errno.h.
      Correct min_of_type handling of _Float128.
      Make float128_private.h work with generic ieee754.h.
      Fix float128_private.h redefinition of SET_RESTORE_ROUNDL.
      Support _Float128 in math-tests.h.
      Support _Float128 in ldbl-96 bits/iscanonical.h.
      Avoid localplt issues from x86 fereaiseexcept inline.
      Make libm-test-support code clear exceptions after each test.
      Update x86 ulps for GCC 7.
      Add float128 support for x86_64, x86.
      Rename struct ucontext tag (bug 21457).
      Add float128 support for ia64.
      Fix strftime build with GCC 8.
      Fix elf/loadtest.c build with GCC 8.
      Miscellaneous sys/ucontext.h namespace fixes (bug 21457).
      Require binutils 2.25 or later to build glibc.
      Add more thorough generated tgmath.h test.
      Remove NO_LONG_DOUBLE conditionals in libm tests (bug 21607).
      Simplify tgmath.h for integer return types.
      Fix tgmath.h totalorder, totalordermag return type (bug 21687).
      Use clog10 not __clog10 in tgmath.h log10 macro.
      Support _Float128 in tgmath.h.
      Fix gen-tgmath-tests.py output for GCC 7 <float.h>.
      SPARC sys/ucontext.h namespace fixes (bug 21457).
      Update versions in build-many-glibcs.py.
      Consistently say "GNU C Library" in NEWS, not "glibc".
      Edit and shorten float128 NEWS item.
      Increase some test timeouts.

Justus Winter (1):
      hurd: Provide truncate64 and ftruncate64.

Kir Kolyshkin (1):
      Add Linux PTRACE_EVENT_STOP

Marko Myllynen (1):
      Fix send consolidation typo

Massimeddu Cireddu (1):
      Fix misspelled yesexpr/day/abday/mon/abmon/date_fmt fields in sc_IT

Matthew Krupcale (1):
      nptl: Fix typo on __have_pthread_attr_t (BZ#21715)

Mike FABIAN (24):
      Bug 20313: Update to Unicode 9.0.0
      Bug 21533: Update to Unicode 10.0.0
      Add ChangeLog entries for the last 6 commits
      Add iI and eE to  yesexpr and noexpr respectively for ts_ZA
      locales/om_ET (LC_MESSAGES): add yesstr and nostr.
      Fix wrong bug number in localedata/ChangeLog
      Fix country name in li_BE and encoding problem in abday in li_BE and li_NL
      Write "Latin" in title case in "title" in hif_FJ locale
      Fix yesexpr in new agr_PE locale
      Use U+02BB MODIFIER LETTER TURNED COMMA instead of U+0027 APOSTROPHE in yesstr and nostr for to_TO locale
      Add country_name to iu_CA locale
      Add int_select to many locales
      Add country_name to several locales
      Mention in NEWS that the Unicode 10.0.0 update causes user visible changes
      Add [BZ #21828] to ChangeLog
      Remove redundant data for LC_MONETARY in sd_IN@devanagari
      Use POSIX Portable Character Set in the new  mai_NP locale source file instead of <Uxxxx>
      Fix inappropriate escape sequences in LC_IDENTIFICATION in several locales
      Fix inappropriate characters in LC_IDENTIFICATION in several locales
      Remove erroneous tabs from some strings in locale files
      Remove erroneous spaces from some strings in locale files
      Revert "Remove redundant data for LC_MONETARY for Indian locales"
      Fix country_name in nds_NL
      Minor improvements to new az_IR locale

Mike Frysinger (5):
      x86_64: fix static build of __mempcpy_chk for compilers defaulting to PIC/PIE
      posix_spawn: fix stack setup on ia64 [BZ #21275]
      posix_spawn: use a larger min stack for -fstack-check [BZ #21253]
      ChangeLog: fix BZ style to be consistent and match majority of existing code
      localedata: CLDRv29: update LC_ADDRESS.lang_name translations

Mousa Moradi (1):
      Add new az_IR locale

Nathan Rossi (2):
      Update Microblaze libm-test-ulps
      microblaze: Resolve non-relocatable branch in pt-vfork.S (BZ#21779)

Paul Clarke (6):
      Support auxilliary vector components for cache geometries.
      powerpc: Add a POWER8-optimized version of cosf()
      powerpc: add sysconf support for cache geometries
      Add powf bench tests
      powerpc: fix sysconf support for cache geometries
      Optimized version of powf()

Paul E. Murphy (11):
      powerpc64le: Create divergent sysdep directory for powerpc64le.
      ldbl-128: Use mathx_hidden_def inplace of hidden_def
      float128: Add _Float128 make bits to libm.
      Add support for testing __STDC_WANT_IEC_60559_TYPES_EXT__
      float128: Add public _Float128 declarations to libm.
      float128: Add private _Float128 declarations for libm.
      float128: Add wrappers to override ldbl-128 as float128.
      float128: Extend the power of ten tables
      float128: Add strtof128, wcstof128, and related functions.
      float128: Add test-{float128,ifloat128,float128-finite}
      powerpc64le: Enable float128

Paul Eggert (1):
      getopt: merge from gnulib: use angle-bracket includes consistently

Peng Wu (1):
      Add yesstr and nostr to zh_CN locale

Phil Blundell (1):
      Correct misplaced comments in struct ip_mreq_source

Prakhar Bahuguna (1):
      [ARM] Optimise memchr for NEON-enabled processors

Rabin Vincent (1):
      [BZ 21357] unwind-dw2-fde: Call free() outside of unwind mutex

Rafal Luzynski (14):
      localedata: Remove trailing spaces [BZ #20275]
      localedata: ce_RU: update weekdays from CLDR [BZ #21207]
      localedata: fur_IT: Fix spelling of Wednesday (Miercus)
      localedata: Month names updated from CLDR-31 [BZ #21217]
      localedata: More months updated from CLDR-31 [BZ #21217]
      localedata: Months updated from CLDR - Arabic scripts [BZ #21217]
      localedata: Months updated from CLDR - Bengali scripts [BZ #21217]
      localedata: Months updated from CLDR - Devanagari scripts [BZ #21217]
      localedata: Months updated from CLDR - other Indic scripts [BZ #21217]
      localedata: Months updated from CLDR - other scripts [BZ #21217]
      More fixes after the recent import from CLDR-31
      Arabic scripts: More fixes after the recent import.
      localedata/locales/lg_UG: Fix some comments.
      Indian scripts: More fixes after the recent import.

Rajalakshmi Srinivasaraghavan (12):
      powerpc: Improve strcmp performance for shorter strings
      powerpc: Use latest optimizations for internal function calls
      powerpc: Set minimum kernel version for powerpc64le
      powerpc: Optimized strncat for POWER8
      powerpc64: strrchr optimization for power8
      powerpc: Fix strncat ifunc selection
      powerpc: Improve memcmp performance for POWER8
      powerpc: Add optimized version of [l]lrintf
      powerpc: Optimize memchr for power8
      powerpc: Add optimized version of [l]lroundf
      powerpc: refactor strrchr IFUNC
      powerpc: Clean up strlen and strnlen for power8

Rical Jasan (14):
      Fix a typo in the manual.
      manual: Fix up invalid header and standards syntax.
      manual: Convert @tables of annotated @items to @vtables.
      manual: Convert errno @comments to new @errno macro.
      manual: Provide consistent errno documentation.
      manual: Create empty placeholder macros for @standards.
      manual: Replace summary.awk with summary.pl.
      manual: Complete @standards in argp.texi.
      manual: Complete @standards in arith.texi.
      manual: Complete @standards in string.texi.
      manual: Complete @standards in lang.texi.
      manual: Fix a minor grammatical error.
      manual: Complete @standards in creature.texi.
      manual: Refactor documentation of CHAR_BIT.

Rogerio A. Cardoso (1):
      powerpc: Fix sinf() IFUNC fallback.

Samuel Thibault (1):
      hurd: Make send/recv more posixish

Santhosh Thottingal (1):
      Correct collation rules for Malayalam.

Siddhesh Poyarekar (40):
      Open master for development
      Fix typo in manual
      Fix getting tunable values on big-endian (BZ #21109)
      Ignore and remove LD_HWCAP_MASK for AT_SECURE programs (bug #21209)
      Actually add bench-memcpy-random
      tunables: Make tunable_list relro
      tunables: Specify a default value for tunables
      tunables: Add support for tunables of uint64_t type
      Reduce value of LD_HWCAP_MASK for tst-env-setuid test case
      Remove useless comment from sysdeps/sparc/sparc32/dl-machine.h
      arm: Fix typo in array count
      Delay initialization of CPU features struct in static binaries
      tunables: Clean up hooks to get and set tunables
      tunables: Add LD_HWCAP_MASK to tunables
      Add include guards to dl-procinfo.h
      tunables: Use glibc.tune.hwcap_mask tunable instead of _dl_hwcap_mask
      aarch64: Allow overriding HWCAP_CPUID feature check using HWCAP_MASK
      Make LD_HWCAP_MASK usable for static binaries
      aarch64: Add hwcap string routines
      aarch64: Fix undefined behavior in _dl_procinfo
      Enable tunables by default
      Fix typo when undefining weak_alias
      benchtests: Print string array elements, int and uint in json
      benchtests: Make memcpy benchmarks print results in json
      benchtests: New script to parse memcpy results
      Add ChangeLog entries for the last 3 commits
      aarch64: Call all string function implementations in tests
      tunables, aarch64: New tunable to override cpu
      Fix typo in glibc.tune.cpu name
      Regenerate libc.pot
      zic: Use PRIdMAX to print line numbers
      sv: Update translation
      Update translations
      Update translations
      Update NEWS
      Update translations
      Add list of bugs fixed in 2.26
      Fix up ChangeLog formatting
      Update contributors and latest gcc and binutils versions
      Update for 2.26 release

Slava Barinov (1):
      fts: Fix symbol redirect for fts_set [BZ #21289]

Stefan Liebler (23):
      Add __glibc_unlikely hint in lll_trylock, lll_cond_trylock.
      Get rid of duplicate const declaration specifier warning in tst-resolv-qtypes.c.
      S390: Optimize atomic macros.
      S390: Regenerate ULPs
      Update auto-libm-test-out for catan / catanh.
      Fix failing test malloc/tst-interpose-nothread with GCC 7.
      S390: Clobber also r14 in TLS_LD, TLS_GD macros on 31bit.
      S390: Use new s390_libc_ifunc_expr macro in s390 8bit-generic.c.
      S390: Move utf8-utf16-z9.c to multiarch folder and use s390_libc_ifunc_expr macro.
      S390: Move utf16-utf32-z9.c to multiarch folder and use s390_libc_ifunc_expr macro.
      S390: Move utf8-utf32-z9.c to multiarch folder and use s390_libc_ifunc_expr macro.
      S390: Regenerate ULPs
      Optimize generic spinlock code and use C11 like atomic macros.
      S390: Use generic spinlock code.
      S390: Fix build with gcc configured with --enable-default-pie. [BZ #21537]
      S390: Sync ptrace.h with kernel. [BZ #21539]
      S390: Save and restore r12 in TLS_IE macro.
      S390: Add new hwcap values for new cpu architecture - arch12.
      S390: Use cu41 instruction for converting from utf32 to utf8.
      S390: Use cu42 instruction for converting from utf32 to utf16.
      S390: Use cu24 instruction for converting from utf16 to utf32.
      S390: Use cu21 instruction for converting from utf16 to utf8.
      S390: Fix tst-ptrace-singleblock if kernel does not support PTRACE_SINGLEBLOCK.

Steve Ellcey (7):
      Add ifunc support for aarch64.
      Add ChangeLog entry for aarch64 ifunc support patch.
      Change TEST_NAME to memcpy to fix IFUNC testing of multiple versions.
      aarch64: Thunderx specific memcpy and memmove
      Fix cexpl when compiled with latest GCC
      Fix nss/nss_test1.c compile with latest GCC.
      Fix localedata test builds with latest GCC

Sunyeop Lee (1):
      Update old tunables framework document/script.

Szabolcs Nagy (8):
      [AArch64] Update libm-test-ulps
      [AArch64] Use hidden __GI__dl_argv in rtld startup code
      [AArch64] Add more cfi annotations to tlsdesc entry points
      Single threaded stdio optimization
      Disable single thread optimization for open_memstream
      Add HWCAP_ macros from Linux 4.12 to AArch64 bits/hwcap.h.
      [AArch64] Fix out of bound array access regression
      [AArch64] Update dl-procinfo for new HWCAP flags in Linux 4.12

Thorsten Kukuk (5):
      If sunrpc code is disabled, rpcsvc header files, rpcgen and
      The rpcgen tests should not run if we don't build rpcgen.
      Add missing ChangeLog entries.
      Deprecate libnsl by default (only shared library will be
      Merge branch 'master' of ssh://sourceware.org/git/glibc

Tulio Magno Quites Machado Filho (12):
      Fix lgamma*, log10* and log2* results [BZ #21171]
      powerpc: Update powerpc-fpu libm-test-ulps
      Use independent type literals in libm-test-support.c
      XFAIL catan and catanh tests on ibm128
      Change the order of function attributes in printf.h
      powerpc: Fix logbl on power7 [BZ# 21280]
      powerpc: Update powerpc-fpu libm-test-ulps
      Move tst-mutex*8* to tests-internal
      Add a way to bypass the PLT when calling getauxval
      powerpc: Update AT_HWCAP[2] bits
      Prevent an implicit int promotion in malloc/tst-alloc_buffer.c
      powerpc: Fix float128 IFUNC relocations [BZ #21707]

Uros Bizjak (1):
      Add earlyclobber to sqrtt/sqrtf insns.

Vladimir Mezentsev (1):
      sparc: handle R_SPARC_DISP64 and R_SPARC_REGISTER relocs

Wainer dos Santos Moschetta (16):
      powerpc: Convert tests to the new support test-driver
      powerpc: Add tests for __ppc_set_ppr_* functions.
      Update string tests to use the support test driver.
      Update wcsmbs tests to use the support test driver
      powerpc64: Add POWER8 strnlen
      Add page tests to string/test-strnlen.
      Update elf tests to use the support test driver.
      powerpc: refactor stpcpy, stpncpy, strcpy, and strncpy IFUNC.
      powerpc: refactor strcasecmp, strcmp, and strncmp IFUNC.
      powerpc: refactor strnlen and strlen IFUNC.
      powerpc: refactor strchr, strchrnul, and strrchr IFUNC.
      powerpc: refactor strcasestr and strstr IFUNC.
      powerpc: refactor memset IFUNC.
      powerpc: refactor memchr, memrchr, and rawmemchr IFUNC.
      powerpc: refactor memcpy and mempcpy IFUNC.
      powerpc: refactor memcmp and memmove IFUNC.

Wilco Dijkstra (11):
      As a minor cleanup remove the (r)index defines from include/string.h as
      GLIBC uses strchr (s, '\0') as an idiom to find the end of a string.
      The internal header include/string.h does not work in C++: it causes link errors
      Remove the str(n)cmp inlines from string/bits/string2.h.  The strncmp
      Remove the str(n)dup inlines from string/bits/string2.h.  Although inlining
      Add a new randomized memcpy test for copies up to 256 bytes.  The distribution
      Replace all internal uses of __bzero with memset.  This removes the need
      2017-06-12  Wilco Dijkstra  <wdijkstr@arm.com>
      Fix build issue on x86.
      Improve math benchmark infrastructure
      Add powf trace

Wladimir J. van der Laan (1):
      Call the right helper function when setting mallopt M_ARENA_MAX (BZ #21338)

Yury Norov (1):
      Test for correct setting of errno.

Zack Weinberg (55):
      Move bits/types.h into posix/bits.
      Clean up redundancies between string.h and strings.h.
      ChangeLog entry for previous changeset
      Add missing header files throughout the testsuite.
      build-many-glibcs: don't crash if email is not configured
      One more obvious missing #include in the testsuite.
      Clean up conditionals for declaration of gets.
      Split DIAG_* macros to new header libc-diag.h.
      Allow direct use of math_ldbl.h in testsuite.
      Miscellaneous low-risk changes preparing for _ISOMAC testsuite.
      Narrowing the visibility of libc-internal.h even further.
      Another round of inclusion fixes for _ISOMAC testsuite.
      getopt: remove USE_NONOPTION_FLAGS
      getopt: merge from gnulib: don't use `...' quotes
      getopt: merge straightforward changes from gnulib
      getopt: fix fencepost error in ambiguous-W-option handling
      getopt: clean up error reporting
      getopt: merge from gnulib: function prototype adjustments
      getopt: tidy up _getopt_initialize a bit
      getopt: refactor long-option handling
      getopt: merge from gnulib: alloca avoidance
      getopt: merge _GL_UNUSED annotations from gnulib
      getopt: eliminate __need_getopt by splitting up getopt.h.
      getopt: annotate files with relationship to gnulib.
      A third round of inclusion fixes for _ISOMAC testsuite.
      Rename cppflags-iterator.mk to libof-iterator.mk, remove extra-modules.mk.
      sunrpc/tst-xdrmem2.c: Include stdint.h.
      Remove _IO_MTSAFE_IO from public headers.
      Suppress internal declarations for most of the testsuite.
      Remove the bulk of the NaCl port.
      Remove sfi_* annotations from ARM assembly files.
      Remove __need_list_t and __need_res_state.
      Remove __need macros from signal.h.
      Add one more header to be installed, missed from previous patch.
      Fix a bug in 'Remove __need macros from signal.h' (a992f506)
      Avoid tickling a linker bug from microblaze pt-vfork.S.
      Add shim header for bits/syscall.h.
      Include shlib-compat.h in many sunrpc/nis source files.
      Add forgotten changelog entry for 82f43dd2d1
      Regenerate sysdeps/gnu/errlist.c.
      Remove __need macros from stdio.h and wchar.h.
      Polish the treatment of dl-tunable-list.h in Makeconfig.
      Remove bare use of __attribute__ in include/errno.h.
      Correct an outdated comment in stdlib/errno.h.
      Remove __need_schedparam and __cpu_set_t_defined.
      Correct indentation in posix/bits/cpu-set.h.
      Remove __need_IOV_MAX and __need_FOPEN_MAX.
      Remove __need macros from errno.h (__need_Emath, __need_error_t).
      Remove bits/string.h.
      Mention in NEWS that __(NO|USE)_STRING_INLINES don't do anything anymore.
      Fix fallout from bits/string.h removal.
      Rename xlocale.h to bits/types/__locale_t.h.
      Use locale_t, not __locale_t, throughout glibc
      Factor out shared definitions from bits/signum.h.
      Reorganize and revise NEWS for 2.26.

-----------------------------------------------------------------------
Comment 7 cvs-commit@gcc.gnu.org 2018-01-04 12:25:24 UTC
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, release/2.25/master has been updated
       via  fc7ef00f02ee41452245926a4f7ff2073711db33 (commit)
       via  8f8022df0773f4867d91068dce71539a4d1574ca (commit)
       via  f67d3f0fa30d923c6e8631e85451da0fd94b86f3 (commit)
       via  e75e7573e1a44faaea833eb1f390def5d6ab672f (commit)
       via  bf19b5fdcde6bae47a17e6173f57f0606a8bd0e9 (commit)
       via  9bb04ec133b30fd106782b2105b8edca93b052e6 (commit)
       via  c3fe737243b7661d8aca2d9f5d76e966f5c537df (commit)
       via  8871213e335854fbe1ae15a3c4b8ba2b7720cf1d (commit)
       via  ea00a80db7c0cd1098f848eccd5d1f34d89b7faf (commit)
       via  ab8b49432b302237015d0f44e858c17f92fe3a5b (commit)
       via  0e64ee798605a042a07604e8a4bf0ec00381e28b (commit)
       via  e3ae300f3f2d1a94709b0f3fed2543b9449a09ca (commit)
       via  e552550b409fda1369dc8f23c659c554632619e5 (commit)
       via  5515224932751ef13d382b7404fefc8e9c1057f5 (commit)
       via  dc2d4b0ccd317108e3fa6f77bbbad238b4b01920 (commit)
       via  196990f97a0a3f28eab25e642f63f1294bf87722 (commit)
       via  346d7f942d1a0193792a6eedf696d797fd000369 (commit)
       via  84e7ab5b1ba14d60d0d76bb78217e254fd4615cf (commit)
       via  1ae1ef2e0d86d4b308636557122ca7a92a5ace80 (commit)
       via  d3f885d7ea9e8a8aa142ccd69e6f85c1a4a70033 (commit)
       via  d8bda0713bd898e9f962cee6d4e3d225441ef5a3 (commit)
       via  dbdcd29e717ecd5217aa1e45a0ffe77a89a3f49b (commit)
       via  6bdff2e237fd167fadb7393c1fb31e0981a0687d (commit)
       via  0fdd895d7786babcae15ce923b3ae3eb54f6140e (commit)
       via  eda5f13d712ae2631165698c017d03d739222f33 (commit)
       via  b091ef7e2f6288a001423a5d037b34663996ffb5 (commit)
       via  8fbf5688edbaead49130b0d2f887335475a298e7 (commit)
       via  1f60575f88769d09c478caa2968b751bca6a90e3 (commit)
       via  8a4bf46fe7256b2713e568589b89c2275975586c (commit)
      from  baf35427d678c86abff1c53594cd923cbcc961da (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=fc7ef00f02ee41452245926a4f7ff2073711db33

commit fc7ef00f02ee41452245926a4f7ff2073711db33
Author: Florian Weimer <fweimer@redhat.com>
Date:   Thu Oct 19 10:44:31 2017 +0200

    nss_files: Avoid large buffers with many host addresses [BZ #22078]
    
    The previous implementation had at least a quadratic space
    requirement in the number of host addresses and aliases.
    
    (cherry picked from commit d8425e116cdd954fea0c04c0f406179b5daebbb3)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=8f8022df0773f4867d91068dce71539a4d1574ca

commit 8f8022df0773f4867d91068dce71539a4d1574ca
Author: Florian Weimer <fweimer@redhat.com>
Date:   Wed Oct 11 07:01:34 2017 +0200

    nss_files: Use struct scratch_buffer for gethostbyname [BZ #18023]
    
    (cherry picked from commit 78e806fd8cd8c918d3bbe1bcdf9091ab365e4a69)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=f67d3f0fa30d923c6e8631e85451da0fd94b86f3

commit f67d3f0fa30d923c6e8631e85451da0fd94b86f3
Author: Florian Weimer <fweimer@redhat.com>
Date:   Tue Oct 10 11:50:41 2017 +0200

    nss_files: Refactor gethostbyname3 multi case into separate function
    
    This is in preparation of further cleanup work.
    
    (cherry picked from commit 8ed70de2faceb4bd7b35bbdc2b7e8c83d9a297ba)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=e75e7573e1a44faaea833eb1f390def5d6ab672f

commit e75e7573e1a44faaea833eb1f390def5d6ab672f
Author: Florian Weimer <fweimer@redhat.com>
Date:   Wed Jun 21 22:43:57 2017 +0200

    Implement allocation buffers for internal use
    
    This commit adds fixed-size allocation buffers.  The primary use
    case is in NSS modules, where dynamically sized data is stored
    in a fixed-size buffer provided by the caller.
    
    Other uses include a replacement of mempcpy cascades (which is
    safer due to the size checking inherent to allocation buffers).
    
    (cherry picked from commit 4dd8e7c0ce5ecc7f65e33e60ad2f717b31de32ec)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=bf19b5fdcde6bae47a17e6173f57f0606a8bd0e9

commit bf19b5fdcde6bae47a17e6173f57f0606a8bd0e9
Author: Florian Weimer <fweimer@redhat.com>
Date:   Wed Sep 6 11:25:14 2017 +0200

    __libc_dynarray_emplace_enlarge: Add missing else
    
    Before, arrays of small elements received a starting allocation size of
    8, not 16.
    
    (cherry picked from commit ab5ac271e6210fa0af11cf3ca525ce573bc47c48)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=9bb04ec133b30fd106782b2105b8edca93b052e6

commit 9bb04ec133b30fd106782b2105b8edca93b052e6
Author: Florian Weimer <fweimer@redhat.com>
Date:   Wed Aug 30 20:10:56 2017 +0200

    dynarray: Set errno on overflow-induced allocation failure
    
    This allows the caller to return directly on such an error, with an
    appropriate errno value.
    
    (cherry picked from commit 5898f4548efdcd7c0fd437a74eeb80facc51a117)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=c3fe737243b7661d8aca2d9f5d76e966f5c537df

commit c3fe737243b7661d8aca2d9f5d76e966f5c537df
Author: Florian Weimer <fweimer@redhat.com>
Date:   Tue Jun 13 17:03:56 2017 +0200

    dynarray: Implement begin/end functions in the spirit of C++
    
    (cherry picked from commit f8bf87face3304f216bcd838081fa33bb4976ac6)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=8871213e335854fbe1ae15a3c4b8ba2b7720cf1d

commit 8871213e335854fbe1ae15a3c4b8ba2b7720cf1d
Author: Florian Weimer <fweimer@redhat.com>
Date:   Fri Jun 2 11:59:28 2017 +0200

    Add internal facility for dynamic array handling
    
    This is intended as a type-safe alternative to obstacks and
    hand-written realloc constructs.  The implementation avoids
    writing function pointers to the heap.
    
    (cherry picked from commit 91b6eb1140eda6bab324821ee3785e5d0ca155b8)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=ea00a80db7c0cd1098f848eccd5d1f34d89b7faf

commit ea00a80db7c0cd1098f848eccd5d1f34d89b7faf
Author: Florian Weimer <fweimer@redhat.com>
Date:   Thu Jan 4 12:51:48 2018 +0100

    Add check_mul_overflow_size_t
    
    Backported from commit 2e0bbbfbf95fc9e22692e93658a6fbdd2d4554da.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=ab8b49432b302237015d0f44e858c17f92fe3a5b

commit ab8b49432b302237015d0f44e858c17f92fe3a5b
Author: Florian Weimer <fweimer@redhat.com>
Date:   Thu Jan 4 12:45:41 2018 +0100

    Add <libc-pointer-arith.h> to help with backporting

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=0e64ee798605a042a07604e8a4bf0ec00381e28b

commit 0e64ee798605a042a07604e8a4bf0ec00381e28b
Author: Florian Weimer <fweimer@redhat.com>
Date:   Thu Jan 4 12:32:36 2018 +0100

    getaddrinfo: Fix error handling in gethosts [BZ #21915] [BZ #21922]
    
    The old code uses errno as the primary indicator for success or
    failure.  This is wrong because errno is only set for specific
    combinations of the status return value and the h_errno variable.
    
    (cherry picked from commit f4a6be2582b8dfe8adfa68da3dd8decf566b3983)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=e3ae300f3f2d1a94709b0f3fed2543b9449a09ca

commit e3ae300f3f2d1a94709b0f3fed2543b9449a09ca
Author: Florian Weimer <fweimer@redhat.com>
Date:   Mon Sep 4 11:25:34 2017 +0200

    getaddrinfo: Return EAI_NODATA if gethostbyname2_r reports NO_DATA [BZ #21922]
    
    (cherry picked from commit 5f8340f583fe3d4f5734bd2371c5a45ecff2db0d)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=e552550b409fda1369dc8f23c659c554632619e5

commit e552550b409fda1369dc8f23c659c554632619e5
Author: Florian Weimer <fweimer@redhat.com>
Date:   Fri Sep 1 08:57:52 2017 +0200

    getaddrinfo: In gaih_inet, use h_errno for certain status values only
    
    h_errno is not set for NSS_STATUS_SUCCESS, so its value might not be
    accurate at this point.
    
    (cherry picked from commit a2881ef01450295782b065f2f850f340d5c12c14)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=5515224932751ef13d382b7404fefc8e9c1057f5

commit 5515224932751ef13d382b7404fefc8e9c1057f5
Author: Florian Weimer <fweimer@redhat.com>
Date:   Fri Sep 1 08:57:28 2017 +0200

    getaddrinfo: Properly set errno for NSS function lookup failure
    
    (cherry picked from commit ad816a5e00ce891a2cea8187638fa0e00f83aaf6)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=dc2d4b0ccd317108e3fa6f77bbbad238b4b01920

commit dc2d4b0ccd317108e3fa6f77bbbad238b4b01920
Author: Florian Weimer <fweimer@redhat.com>
Date:   Fri Sep 1 08:57:07 2017 +0200

    getaddrinfo: Use &h_errno has the h_errno pointer
    
    This simplifies the code because it is not necessary to propagate the
    temporary h_errno value to the thread-local variable.  It also increases
    compatibility with NSS modules which update only one of the two places.
    
    (cherry picked from commit 53250a21b81474ef4e78090a4a9a63d8471e1091)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=196990f97a0a3f28eab25e642f63f1294bf87722

commit 196990f97a0a3f28eab25e642f63f1294bf87722
Author: Florian Weimer <fweimer@redhat.com>
Date:   Fri Sep 1 08:56:46 2017 +0200

    getaddrinfo: Use &errno has the errno pointer
    
    Similar code in nss/getXXbyYY_r.c is already using &errno as the
    argument.
    
    (cherry picked from commit 924b121c5978689001ae28cf1c8497371dad4f71)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=346d7f942d1a0193792a6eedf696d797fd000369

commit 346d7f942d1a0193792a6eedf696d797fd000369
Author: Florian Weimer <fweimer@redhat.com>
Date:   Tue Aug 8 18:48:05 2017 +0200

    getaddrinfo: Remove unreachable return statement from gaih_inet
    
    (cherry picked from commit 0df595b23a829c9169ec418a19eef9006b4ae801)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=84e7ab5b1ba14d60d0d76bb78217e254fd4615cf

commit 84e7ab5b1ba14d60d0d76bb78217e254fd4615cf
Author: Florian Weimer <fweimer@redhat.com>
Date:   Sat Jun 24 16:51:31 2017 +0200

    resolv/tst-resolv-basic: Add test cases for bug 21295
    
    (cherry picked from commit 513a71a420e74270a6a9702ec916e807be51350a)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=1ae1ef2e0d86d4b308636557122ca7a92a5ace80

commit 1ae1ef2e0d86d4b308636557122ca7a92a5ace80
Author: Dmitry Bilunov <kmeaw@kmeaw.com>
Date:   Thu Jan 4 11:33:53 2018 +0100

    getaddrinfo: Merge IPv6 addresses and IPv4 addresses [BZ #21295]
    
    (cherry picked from commit 5cf88a83f27b0cd2d5a83511930e40d716c939eb)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=d3f885d7ea9e8a8aa142ccd69e6f85c1a4a70033

commit d3f885d7ea9e8a8aa142ccd69e6f85c1a4a70033
Author: Florian Weimer <fweimer@redhat.com>
Date:   Thu May 11 11:32:16 2017 +0200

    support_format_addrinfo: Fix flags and canonname formatting
    
    The address family splitting via format_ai_family made unpredictable
    the place where the canonname field was printed.  This commit adjusts
    the implementation so that the ai_flags is checked for consistency
    across the list, and ai_canonname must only be present on the first
    list element.
    
    Tests for AI_CANONNAME are added to resolv/tst-resolv-basic.
    
    (cherry picked from commit 8ec69bb7ecf3ca5edde5b7d9d7d5d3a5f8b6c405)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=d8bda0713bd898e9f962cee6d4e3d225441ef5a3

commit d8bda0713bd898e9f962cee6d4e3d225441ef5a3
Author: Florian Weimer <fweimer@redhat.com>
Date:   Thu Jan 4 11:45:20 2018 +0100

    resolv: Support an exactly sized buffer in ns_name_pack [BZ #21359]
    
    This bug did not affect name resolution because those functions
    indirectly call ns_name_pack with a buffer which is always larger
    than the generated query packet, even in the case of the
    longest-possible domain name.
    
    (cherry picked from commit c803cb9b24c6cea15698768e4301e963b98e742c)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=dbdcd29e717ecd5217aa1e45a0ffe77a89a3f49b

commit dbdcd29e717ecd5217aa1e45a0ffe77a89a3f49b
Author: Florian Weimer <fweimer@redhat.com>
Date:   Tue Apr 4 14:09:56 2017 +0200

    resolv: Add test coverage for ns_name_unpack, ns_name_ntop
    
    (cherry picked from commit 07d6f1a3ca990e0e4f93b010605d4d87a3abdf24)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=6bdff2e237fd167fadb7393c1fb31e0981a0687d

commit 6bdff2e237fd167fadb7393c1fb31e0981a0687d
Author: Florian Weimer <fweimer@redhat.com>
Date:   Wed Jun 21 13:35:37 2017 +0200

    getaddrinfo: Avoid stack copy of IPv6 address
    
    (cherry picked from commit 76b8266f990a2912f42d1b7050840e8c7f14f2c2)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=0fdd895d7786babcae15ce923b3ae3eb54f6140e

commit 0fdd895d7786babcae15ce923b3ae3eb54f6140e
Author: Florian Weimer <fweimer@redhat.com>
Date:   Wed Jun 21 13:09:08 2017 +0200

    __inet_pton_length: Implement new internal helper function
    
    (cherry picked from commit 60149b28590be28051f99d0a343d7fbe002f2a8c)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=eda5f13d712ae2631165698c017d03d739222f33

commit eda5f13d712ae2631165698c017d03d739222f33
Author: Florian Weimer <fweimer@redhat.com>
Date:   Thu May 11 14:48:51 2017 +0200

    inet_pton: Reformat in GNU style
    
    Generated machine code is identical on x86-64.
    
    (cherry picked from commit d53b8652880ba42913f66e7eee0567ce4cfe7791)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=b091ef7e2f6288a001423a5d037b34663996ffb5

commit b091ef7e2f6288a001423a5d037b34663996ffb5
Author: Florian Weimer <fweimer@redhat.com>
Date:   Sat Jun 3 08:37:13 2017 +0200

    getaddrinfo: Eliminate another strdup call
    
    (cherry picked from commit 363911ce1313a246b7d33f0983a09e7ab2525b3a)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=8fbf5688edbaead49130b0d2f887335475a298e7

commit 8fbf5688edbaead49130b0d2f887335475a298e7
Author: Florian Weimer <fweimer@redhat.com>
Date:   Fri Jun 2 16:35:13 2017 +0200

    getaddrinfo: Fix localplt failure involving strdup
    
    (cherry picked from commit 6257fcfd58479f6b7ae0fdde045b9ff144d543da)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=1f60575f88769d09c478caa2968b751bca6a90e3

commit 1f60575f88769d09c478caa2968b751bca6a90e3
Author: Florian Weimer <fweimer@redhat.com>
Date:   Fri Jun 2 14:54:56 2017 +0200

    getaddrinfo: Always allocate canonical name on the heap
    
    A further simplification could eliminate the canon variable in
    gaih_inet and replace it with canonbuf.  However, canonbuf is
    used as a flag in the nscd code, which makes this somewhat
    non-straightforward.
    
    (cherry picked from commit 673cb072a4710bd4bf6029a062d2867cca929c43)

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=8a4bf46fe7256b2713e568589b89c2275975586c

commit 8a4bf46fe7256b2713e568589b89c2275975586c
Author: Florian Weimer <fweimer@redhat.com>
Date:   Thu May 11 10:01:49 2017 +0200

    getaddrinfo: Unconditionally use malloc for address list
    
    getaddrinfo has to call malloc eventually anyway, so the complexity
    of avoiding malloc calls is not worth potential savings.
    
    (cherry picked from commit 46ce8881ade788db56079622f47f648d4aaa003b)

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog                            |  253 +++++++++++++
 NEWS                                 |    5 +
 include/alloc_buffer.h               |  367 +++++++++++++++++++
 include/libc-pointer-arith.h         |    1 +
 malloc/Makefile                      |   30 ++-
 malloc/Versions                      |   14 +
 malloc/alloc_buffer_alloc_array.c    |   47 +++
 malloc/alloc_buffer_allocate.c       |   36 ++
 malloc/alloc_buffer_copy_bytes.c     |   34 ++
 malloc/alloc_buffer_copy_string.c    |   30 ++
 malloc/alloc_buffer_create_failure.c |   31 ++
 malloc/dynarray-skeleton.c           |  521 ++++++++++++++++++++++++++
 malloc/dynarray.h                    |  176 +++++++++
 malloc/dynarray_at_failure.c         |   31 ++
 malloc/dynarray_emplace_enlarge.c    |   73 ++++
 malloc/dynarray_finalize.c           |   62 ++++
 malloc/dynarray_resize.c             |   64 ++++
 malloc/dynarray_resize_clear.c       |   35 ++
 malloc/malloc-internal.h             |   19 +
 malloc/tst-alloc_buffer.c            |  665 ++++++++++++++++++++++++++++++++++
 malloc/tst-dynarray-at-fail.c        |  125 +++++++
 malloc/tst-dynarray-fail.c           |  418 +++++++++++++++++++++
 malloc/tst-dynarray-shared.h         |   80 ++++
 malloc/tst-dynarray.c                |  574 +++++++++++++++++++++++++++++
 nss/Makefile                         |    9 +
 nss/nss_files/files-hosts.c          |  400 +++++++++++----------
 nss/tst-nss-files-hosts-erange.c     |  109 ++++++
 nss/tst-nss-files-hosts-multi.c      |  331 +++++++++++++++++
 resolv/Makefile                      |    8 +
 resolv/Versions                      |    1 +
 resolv/inet_pton.c                   |  361 ++++++++++---------
 resolv/ns_name.c                     |    2 +-
 resolv/resolv-internal.h             |    9 +
 resolv/tst-inet_pton.c               |  549 ++++++++++++++++++++++++++++
 resolv/tst-ns_name.c                 |  438 ++++++++++++++++++++++
 resolv/tst-ns_name.data              |  548 ++++++++++++++++++++++++++++
 resolv/tst-ns_name_compress.c        |   75 ++++
 resolv/tst-resolv-basic.c            |  240 +++++++++++--
 sysdeps/posix/getaddrinfo.c          |  327 +++++++----------
 39 files changed, 6509 insertions(+), 589 deletions(-)
 create mode 100644 include/alloc_buffer.h
 create mode 100644 include/libc-pointer-arith.h
 create mode 100644 malloc/alloc_buffer_alloc_array.c
 create mode 100644 malloc/alloc_buffer_allocate.c
 create mode 100644 malloc/alloc_buffer_copy_bytes.c
 create mode 100644 malloc/alloc_buffer_copy_string.c
 create mode 100644 malloc/alloc_buffer_create_failure.c
 create mode 100644 malloc/dynarray-skeleton.c
 create mode 100644 malloc/dynarray.h
 create mode 100644 malloc/dynarray_at_failure.c
 create mode 100644 malloc/dynarray_emplace_enlarge.c
 create mode 100644 malloc/dynarray_finalize.c
 create mode 100644 malloc/dynarray_resize.c
 create mode 100644 malloc/dynarray_resize_clear.c
 create mode 100644 malloc/tst-alloc_buffer.c
 create mode 100644 malloc/tst-dynarray-at-fail.c
 create mode 100644 malloc/tst-dynarray-fail.c
 create mode 100644 malloc/tst-dynarray-shared.h
 create mode 100644 malloc/tst-dynarray.c
 create mode 100644 nss/tst-nss-files-hosts-erange.c
 create mode 100644 nss/tst-nss-files-hosts-multi.c
 create mode 100644 resolv/tst-inet_pton.c
 create mode 100644 resolv/tst-ns_name.c
 create mode 100644 resolv/tst-ns_name.data
 create mode 100644 resolv/tst-ns_name_compress.c